<?php
/**
* @version 1.0.0
* @package RSSearch! 1.0.0
* @copyright (C) 2012 www.rsjoomla.com
* @license GPL, http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die('Restricted access');
jimport('joomla.form.formfield');

class JFormFieldSobiprocategories extends JFormField {

	/**
	 * The form field type.
	 *
	 * @var		string
	 * @since	1.6
	 */
	protected $type = 'Sobiprocategories';
	/**
	 * Method to get the field input markup.
	 *
	 * @return	string	The field input markup.
	 * @since	1.6
	 */

	protected function getInput() {
		if (file_exists(JPATH_SITE.'/components/com_sobipro/sobipro.php')) {
			$options = $this->getOptions();
			return JHTML::_('select.genericlist', $options, $this->name.'[]', 'class="input-xxlarge" size="10" multiple="multiple"', 'value', 'name', $this->value);
		}
	}
	
	protected function getOptions() {
		$db			= JFactory::getDBO();
		$options	= array();

		$db->setQuery('SELECT '.$db->qn('id').', '.$db->qn('name').', '.$db->qn('parent').', '.$db->qn('oType').' FROM '.$db->qn('#__sobipro_object').' WHERE '.$db->qn('oType').' IN ('.$db->q('section').','.$db->q('category').' ) ORDER BY `id` ASC');

		if ($objects = $db->loadObjectList()) 
		{
			foreach($objects as $object) {
				$option 				= new stdClass();
				$option->value 			= $object->id;
				$option->name  			= $object->name;
				if (empty($object->name)) {
					$option->name = $this->getTranslatedCat($object->id);
				}
				$option->parent			= $object->parent;
				
				$parent = $object->parent;
				while ($parent > 0) {
					foreach ($objects as $i => $tmp_object) {
						if ($tmp_object->id == $parent) {
							$parent = 0;
							if (empty($tmp_object->name)) {
								$tmp_object->name = $this->getTranslatedCat($tmp_object->id);
							}
							$option->name = $tmp_object->name.' - '.$option->name;
							if ($tmp_object->parent > 0)
								$parent = $tmp_object->parent;
							break;
						}
						if ($i == count($objects)-1)
							$parent = 0;
					}
				}
				$options[] = $option;
			}
			sort($options);
		}

		return $options;
	}

	private function getTranslatedCat($category_id) 
	{
		$lang	= JFactory::getLanguage();
		$db 	= JFactory::getDBO();
		$db->setQuery('SELECT sValue FROM '.$db->qn('#__sobipro_language').' WHERE '.$db->qn('sKey').' = '.$db->q('name').' AND '.$db->qn('language').' = '.$db->q($lang->get('tag')).' AND '.$db->qn('id').' = '.$db->q((int) $category_id));
		
		return $db->loadResult();
	}
	
}