<?php
/**
* @version 1.0.0
* @package RSSearch! 1.0.0
* @copyright (C) 2012 www.rsjoomla.com
* @license GPL, http://www.gnu.org/licenses/gpl-2.0.html
*/
defined( '_JEXEC' ) or die( 'Restricted access' );
jimport('joomla.plugin.plugin');
 
class plgRSSearchSobiPro extends JPlugin
{
	public function __construct( &$subject, $config ) {
		parent::__construct( $subject, $config );
	}

	public function getResults(&$results, $search, $params) {
	    $db				= JFactory::getDBO();
	    $fields 		= (array) $this->params->get('searchfields','');
	    $orderby 		= $this->params->get('orderby','name');
	    $categories 	= (array) $this->params->get('sobiprocategories','');
	    $asc_desc 		= $this->params->get('asc_desc','ASC');
	    $itemId 		= $this->params->get('Itemid','');
	    $itemId 		= (empty($itemId) ? '' : '&Itemid='.$itemId);
		$tablecolumns 	= array('name','createdTime','counter');
		
		JFactory::getLanguage()->load('plg_rssearch_sobipro',JPATH_ADMINISTRATOR);

		require_once JPATH_ADMINISTRATOR . '/components/com_search/helpers/search.php';

		foreach($fields as $field){
			if ($field == 'sobipro_items') 
			{
				$where_catid = '';
				if (in_array('sobipro_categories', $fields)) {
					if (!in_array('', $categories)) {
						JArrayHelper::toInteger($categories);
						$where_catid = ' AND ('.$db->qn('o.parent').' IN ('.implode(',', $categories).') OR '.$db->qn('r.pid').' IN ('.implode(',', $categories).') )';
					}
				}

				$query = 'SELECT DISTINCT '.$db->qn('fd.sid').', '.$db->qn('o.nid').', '.$db->qn('o.parent').' 
				FROM '.$db->qn('#__sobipro_object','o').' 
				LEFT JOIN '.$db->qn('#__sobipro_field_data','fd').' ON '.$db->qn('o.id').' = '.$db->qn('fd.sid').' 
				LEFT JOIN '.$db->qn('#__sobipro_relations','r').' ON '.$db->qn('o.id').' = '.$db->qn('r.id').' 
				WHERE '.$db->qn('o.oType').' = '.$db->q('entry').' AND 
				('.$db->qn('o.name').' LIKE '.$db->q('%'.$search.'%').' OR '.$db->qn('fd.baseData').' LIKE '.$db->q('%'.$search.'%').') AND 
				'.$db->qn('fd.fid').' IN (1,8,9) AND 
				'.$db->qn('o.state').' = 1 AND 
				'.$db->qn('o.approved').' = 1 
				'.$where_catid;

				if (in_array($orderby,$tablecolumns))
					$query .= ' ORDER BY '.$db->qn('o.'.$orderby).' '.$db->escape($asc_desc);

				$db->setQuery($query);
				if ($list = $db->loadObjectList()) {
					foreach ($list as $item) 
					{
						$db->setQuery('SELECT '.$db->qn('baseData').' FROM '.$db->qn('#__sobipro_field_data').' WHERE '.$db->qn('fid').' = 1 AND '.$db->qn('sid').' = '.(int) $item->sid.'');
						$item->name = $db->loadResult();
						$db->setQuery('SELECT '.$db->qn('baseData').' FROM'.$db->qn('#__sobipro_field_data').' WHERE '.$db->qn('fid').' = 9 AND '.$db->qn('sid').' = '.(int) $item->sid.'');
						$item->desc = $db->loadResult();

						if ( !searchHelper::checkNoHTML($item, $search, array('name', 'desc')) ) continue;

						$tmp		= new stdClass();
						$tmp->title = $item->name;
						$tmp->link 	= JRoute::_('index.php?option=com_sobipro&pid='.$item->parent.'&sid='.$item->sid.':'.$item->nid.$itemId);
						$tmp->text 	= $item->desc;
						$tmp->type 	= JText::_('RSS_SOBIPRO_XML_ENTRY');
						$results[] 	= $tmp;
					}
				}
			}
			elseif($field == 'sobipro_categories') 
			{
				$where_catids = '';

				if (!in_array('', $categories)) {
					JArrayHelper::toInteger($categories);
					$where_catids 	= ' AND '.$db->qn('o.id').' IN ('.implode(',', $categories).' )';
				}
				
				$query = 'SELECT '.$db->qn('o.id').', '.$db->qn('o.nid').', '.$db->qn('o.name').', '.$db->qn('o.parent').', '.$db->qn('c.description').', ln.sValue as trans_name, ld.sValue as trans_desc
				FROM '.$db->qn('#__sobipro_object','o').' 
				LEFT JOIN '.$db->qn('#__sobipro_category','c').' ON '.$db->qn('o.id').' = '.$db->qn('c.id').' 
				LEFT OUTER JOIN '.$db->qn('#__sobipro_language','ln').' ON ('.$db->qn('o.id').' = '.$db->qn('ln.id').' AND '.$db->qn('ln.sKey').' = '.$db->q('name').')
				LEFT OUTER JOIN '.$db->qn('#__sobipro_language','ld').' ON ('.$db->qn('o.id').' = '.$db->qn('ld.id').' AND '.$db->qn('ld.sKey').' = '.$db->q('description').')
				WHERE '.$db->qn('o.oType').' IN ('.$db->q('category').','.$db->q('section').') AND 
				('.$db->qn('o.name').' LIKE '.$db->q('%'.$search.'%').' OR '.$db->qn('c.introtext').' LIKE '.$db->q('%'.$search.'%').' OR '.$db->qn('c.description').' LIKE '.$db->q('%'.$search.'%').') AND 
				'.$db->qn('o.approved').' = 1 AND 
				'.$db->qn('o.state').' = 1 '.$where_catids;

				if (in_array($orderby,$tablecolumns))
					$query .= ' ORDER BY '.$db->qn($orderby).' '.$db->escape($asc_desc);

				$db->setQuery($query);
				
				if ($list = $db->loadObjectList()) {
					foreach ($list as $item) {
						if ( !searchHelper::checkNoHTML($item, $search, array('name', 'introtext', 'description', 'trans_name', 'trans_desc')) ) continue;

						$tmp		= new stdClass();
						$tmp->title = !empty($item->trans_name) ? $item->trans_name : $item->name;
						$tmp->link 	= JRoute::_('index.php?option=com_sobipro&sid='.$item->id.':'.str_replace(' ','-',$item->nid).$itemId);
						$tmp->text 	= !empty($item->trans_desc) ? $item->trans_desc : $item->description;
						$tmp->type 	= JText::_('RSS_SOBIPRO_XML_CATEGORY');
						$results[] 	= $tmp;
					}
				}
			}
		}
	    return true;
	}

}